import 'package:k3cloud_api/params/request_param.dart';

/// it is used to build parameters to request the audit interface.
class AuditParam extends RequestParam {
  @override
  String getRequestPath() {
    return "DynamicFormService.Audit";
  }

  @override
  Map<String, dynamic> toJson() {
    Map<String, dynamic> data = {};
    if (createOrgId != null) data["createOrgId"] = createOrgId;
    if (numbers != null) data["numbers"] = numbers;
    if (ids != null) data["ids"] = ids;
    if (networkCtrl != null) data["networkCtrl"] = networkCtrl;
    if (interationFlags != null) data["interationFlags"] = interationFlags;

    Map<String, dynamic> json = {};
    if (formId != null) json["formId"] = formId;
    json["data"] = data;
    return json;
  }

  String? formId;
  int? createOrgId;
  List<String>? numbers;
  List<int>? ids;
  bool? networkCtrl;
  String? interationFlags;

  static _Builder builder() {
    return _Builder();
  }
}

class _Builder {
  final AuditParam _param = AuditParam();

  AuditParam build() => _param;
  
  _Builder formId(String formId) {
    _param.formId = formId;
    return this;
  }

  _Builder createOrgId(int createOrgId) {
    _param.createOrgId = createOrgId;
    return this;
  }

  _Builder numbers(List<String> numbers) {
    _param.numbers = numbers;
    return this;
  }

  _Builder ids(List<int> ids) {
    _param.ids = ids;
    return this;
  }

  _Builder networkCtrl(bool networkCtrl) {
    _param.networkCtrl = networkCtrl;
    return this;
  }

  _Builder interationFlags(List<String> interationFlags) {
    _param.interationFlags = interationFlags.join(";");
    return this;
  }
}